--
-- ZHVN_by_Aluha74rus
-- Specialization for ZHVN_by_Aluha74rus
--
-- @author  	Manuel  Aluha74rus
-- @version 	v1.0
-- @date  		28/09/18
--

ZHVN = {};

function ZHVN.prerequisitesPresent(specializations)
    return true;
end;
function ZHVN:load(savegame)
   Utils.checkDeprecatedXMLElements(self.xmlFile, self.configFileName, "vehicle.zhvnEffects#baseNode", "vehicle.zhvn.effect#baseNode")


    if self.isClient then
        self.zhvnEffectBaseNode = Utils.getNoNil(Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.zhvn.effect#baseNode")), self.rootNode)
        self.zhvnEffects = {}
        self.currentZhvnEffect = nil
        if hasXMLProperty(self.xmlFile, "vehicle.zhvn.effect") then
            for fruitTypeIndex,_ in pairs(self.fruitTypes) do
                self.zhvnEffects[fruitTypeIndex] = {}
                local i = 0
                while true do
                    local key = string.format("vehicle.zhvn.effect.effectNode(%d)", i)
                    if not hasXMLProperty(self.xmlFile, key) then
                        break
                    end
                    local effect = ZhvnEffect:new()
                    effect:load(self.xmlFile, key, self.components, self, fruitTypeIndex)
                    table.insert(self.zhvnEffects[fruitTypeIndex], effect)
                    i = i + 1
                end
            end
        end
    end
	
end;
function ZHVN:postLoad(xmlFile)
end;
function ZHVN:delete()
    if self.isClient then
        for _, effectAttribute in pairs(self.zhvnEffects) do
            EffectManager:deleteEffects(effectAttribute.effect)
        end
    end
end;
function ZHVN:mouseEvent(posX, posY, isDown, isUp, button)
end;
function ZHVN:keyEvent(unicode, sym, modifier, isDown)
end;
function ZHVN:update(dt)
end;
function ZHVN:updateTick(dt)
    if self:getIsActive() then
        if self:getIsTurnedOn() then
            local hasGroundContact, typedWorkAreas = self:getIsTypedWorkAreaActive(WorkArea.AREATYPE_MOWER)
            if hasGroundContact then

            if self.currentInputFruitType ~= nil then
                local newEffect = self.zhvnEffects[self.currentInputFruitType]
                if newEffect ~= nil then
                    if self.currentZhvnEffect ~= newEffect then
                        EffectManager:resetEffects(self.currentZhvnEffect)
                    end
                    self.currentZhvnEffect = newEffect
                    for _, effect in pairs(self.currentZhvnEffect) do
                        if effect.setGrowthState ~= nil then
                            effect:setGrowthState(self.currentInputFruitTypeGrowthState)
                        end
                        if effect.setMinMax ~= nil then
                            effect:setMinMax(minEffectValue, maxEffectValue, reset)
                        end
                    end
                else
                    if self.currentZhvnEffect ~= nil then
                        EffectManager:resetEffects(self.currentZhvnEffect)
                    end
                end
            end
            end
        end
    else
        if self.currentZhvnEffect ~= nil then
            for _, effect in pairs(self.currentZhvnEffect) do
                if effect.setMinMax ~= nil then
                    effect:setMinMax(0, 0, true)
                end
            end
        end
    end
end
function ZHVN:draw()    
end;
function ZHVN:onLeave()
end;
function ZHVN:onDeactivate()
end;
function Mower:setEffectEnabled(mowerEffect, isActive)
    mowerEffect.isActive = isActive
    if self.isClient then
        if isActive then
            EffectManager:setFillType(mowerEffect.effects, FillUtil.FILLTYPE_GRASS_WINDROW)
            EffectManager:startEffects(mowerEffect.effects)
        else
            EffectManager:stopEffects(mowerEffect.effects)
        end
         if self.currentZhvnEffect ~= nil then
            EffectManager:resetEffects(self.currentZhvnEffect)
        end
    end
end